/*
  g++ -g test-householder.cc -o thh -ltobiMath

 */
#include<iostream>
#include<tobiMath.hh>

main()
{
  int rank;
  int n, m, i, j;
  int* p;
  double** A;
  double** QR;
  double* d;
  double* x;
  double* y;

  double tmp,tmp2;

  cin >> n;
  cin >> m;

//      if( n<m )
//      {
//        cerr << "\n Error: n<m" << endl;
//        return -1;
//      }

  A = new_matrix(n,m);
  QR = new_matrix(n,m);
  d = new double[m];
  x = new double[n];
  y= new double [n];
  p= new int [m];

  if( A==NULL || QR == NULL || d==NULL  || x==NULL || y==NULL || p==NULL )
    {
      cerr << "\n Memory allocation error." << endl;
      return -1;
    }

  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      cin >> A[i][j];

  for(i=0;i<n;i++)
    cin >> y[i];

  decomp_householder_pivot = always;
  decomp_householder_eps = 1.0e-5;

  cout << "\n Solving the system A x = y" << endl;

  for(i=0;i<n;i++)
      x[i] = y[i];

  copy_matrix(n,m,QR,A);
  
  rank = lin_solve_householder(n,m,QR,d,p,x);

  if( rank < 0 )
    {
      cerr << "\n Error. " << endl;
      return -1;
    }

  if( m != rank )
    {
      cerr << "\n Warning: rank(A) = " << rank << " < m = "<< m << endl;
    }

  cout << "\n Solution: x= (" << x[0];
  for(i=1;i<m;i++) cout << ", " << x[i];
  cout << ")"<<endl;
  
  cout << "\n Permutation vector p= (" << p[0];
  for(i=1;i<m;i++) cout << ", " << p[i];
  cout << ")"<<endl;
  

  cout << "\n Diagonal elements of R:\n (" << d[0];
  for(i=1;i<rank;i++)
    cout << ", " << d[i];
  
  cout << ")\n\n\n Test: A x - y = ( " ;

  for(tmp2=0.0,i=0;i<n;i++)
    {
      for(j=0,tmp=0.0;j<m;j++)
	tmp += A[i][j]*x[j];
      tmp=tmp - y[i];
      tmp2 += tmp*tmp;
      cout <<  tmp << (i < n-1 ? ", " : ")" );
    }
  cout << "\n ||Ax-y|| = " << sqrt(tmp2) << endl;

  delete_matrix(n,A);
  delete_matrix(n,QR);
  delete [] d;
  delete [] p;
  delete [] x;
  delete [] y;
  return 0;
}

