/*
  g++ -g test2mat.cc -ltobiMath  -o test2mat

  test2mat <<EOF > test2d.dat
  10
  5
  3
  EOF

 */
#include<tobiMath.hh>
#include<iostream>

main()
{
  int i,j,k;
  int n, m, rank;
  double tmp;
  double **A;
  double *b;

  cin >> n; cout << n<< endl;
  cin >> m; cout << m<< endl;
  cin >> rank;

  A = new_matrix(n,m);
  b = new double[n];

  for(i=0;i<n;i++)
    for(j=0;j<rank;j++)
      A[i][j]=rint(100.0*rand_gauss());
  
  for(i=rank;i<m;i++)
    {
      for(j=0;j<n;j++) A[j][i]=0.0;

      for(j=0;j<rank;j++)
	{
	  tmp=rint(100.0*rand_gauss());
	  for(k=0;k<n;k++)
	    A[k][i] += tmp*A[k][j];
	}
    }

  for(i=0;i<n;i++) b[i] = 0.0;

  for(i=1;i<rank;i++)
    {
      tmp = rand_gauss();
      for(j=0;j<n;j++)
	b[j] += tmp * A[j][i];
    }

  //////////////////////////////////////////////////////////////////////
  // Output:

  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	  cout << A[i][j] << " ";
      cout << endl;
    }

  cout << endl;

  for(i=0;i<n;i++)
    cout << b[i] << " ";

  cout << endl;

  delete_matrix(n,A);
  delete [] b;
}
