#include"tobiMat.hh"

ostream& operator << (ostream& os, const t_v a)
{
  int i;
  
  os << "[ ";
  
  if( a.size() > 0 )  os << a[0];
  for(i=1;i < a.size(); i++)
    os << ", " << a[i];

  os << " ]";

  return os;
}

// matrix - matrix - product
t_m t_m::operator * (const t_m& b) const
{
  int i,J,Jb,k,K;
  double tmp;
  t_m c(m,b.n);
  for(i=0;i<m;i++)
    for(J=Jb=0; Jb<b.N; Jb+=b.m, J+=m)
      {
	tmp=0.0;
	for(k=0,K=0;k<n;k++,K+=m)
	  tmp += operator[](i+K) * b[k+Jb];
	c[i+J] = tmp;
      }
  return c;
}

double norm(const t_v& v) // Euclidian norm of v
{
  int i;
  double ret=0.0;
  for(i=0;i<v.size();i++)
    ret += v[i]*v[i];
  return sqrt(ret);
}

