#ifndef TOBIMATH_HH
#define TOBIMATH_HH
#include<iostream>
#include<math.h>
#include<stdlib.h>
extern int my_double_count;

// // for debugging:
//  class mydouble
//  {
//    double my_val;
//  public:
//    mydouble() {my_val = 0.0; my_double_count++; cout <<'+';}
//    mydouble(const double& val) { my_val = val; my_double_count++; cout <<'+';}
//    ~mydouble(){ my_double_count--;
//    cout << '-';
//    }
//    operator double ()
//    {
//      return my_val;
//    }
//  };


inline double sqr(double x) {return x*x;}
double pow(double x,int y);

inline double frand() {return ((double) rand())/((double) RAND_MAX);}

#ifndef M_SQRTPI_4
#define M_SQRTPI_4 0.443113462726
#endif

inline double rand_gauss() {
  /*
    Just an roughly approximation:
  */
  double x = frand();
  return M_SQRTPI_4*log(x/(1-x));
}

double** new_matrix(int n, int m);
void delete_matrix(int n, double** A);

void copy_matrix(int n, int m, double** A, double** B);

double norm_inf(int dim, double* v);

double norm2(int dim, double* v);

double* sort_abs(int dim, double* v);

#define norm2sort(dim, v) norm2(dim, sort_abs(dim, v))

bool lin_solve_gauss(int dim, double** A, double* b);

bool lin_solve_cholesky(int dim, double** S, double* b);

enum decomp_householder_pivot_t {sometimes, always };
extern decomp_householder_pivot_t decomp_householder_pivot;
extern double decomp_householder_eps;
int decomp_householder(int n, int m, double** A, double* d, int* p );
// bool solve_householder(int n, int m, double** A, double *d, int* p, double* xy);
int lin_solve_householder(int n, int m, double** A, double *d, int* p, double* xy);

class t_interpolate
{
  double* my_w;
  double* my_w2;
  int my_n;
public:
  t_interpolate(int n = 5);
  ~t_interpolate();
  double operator () (
		      int n,
		      double t,
		      double *t_points,
		      double *x_points
		      );
  double operator () (
		      int n,
		      double t,
		      double *t_points,
		      double *x_points,
		      double *dxdt
		      );  
};

extern t_interpolate interpolate;

#endif // DEF TOBIMATH_HH
