######################################################################
#
# Nichtrelativistische Bahnkurve eines Elektrons, das einen
# geladenen Plattenkondensator endlicher Ausdehnung durchfliegt.
#
# Die Platten des Plattenkondensators sind parallel zur x-y-Ebene.
# Das Elektron tritt mit einer Anfangsgeschwindigkeit in x-Richtung
# auf der x-Achse in das Feld des Plattenkondensators ein.
######################################################################

set style data lines
set xrange [-2:8]

# y-Ablenkung in Abh"angigkeit der x-Koordinate des Elektrons:
######################################################################
set term table
set output "tmp.dat"
set contour
set cntrparam levels incr 0.0,0.1,0.9
unset sur
splot  'pot.dat' using (100*$1):(100*$2):3 with lines 0,\
       'pot.dat' using (-100*$1):(100*$2):3 with lines 0

######################################################################
set term post eps       
set auto
set xrange [-2:8]
set nokey
set xtics auto
set ytics auto
set noztics
unset grid
set noborder
set nokey
set xlabel 'x/cm'
set title 'Bahnkurve (Up=100V)'
set ylabel 'y/cm'
set output 'bahnkurve100.eps'
plot 'bahnkurve.dat' using (100*$3):(100*$4), 'tmp.dat'
set title 'vx(x) (Up=100V)'
set ylabel 'vx(x)/(m/us)'
set output 'geschw-x-100.eps'
plot 'bahnkurve.dat' using (100*$3):(1000*$5)
set title 'vy(x) (Up=100V)'
set ylabel 'vy/(m/us)'
set output 'geschw-y-100.eps'
plot 'bahnkurve.dat' using (100*$3):(1000*$6)
set title '|v(x)|'
set ylabel '|v(x)|/(m/us)'
set output 'geschw-100.eps'
plot 'bahnkurve.dat' using (100*$3):(1000*$12)
set title 'Ex(x) (Up=100V)'
set ylabel 'Ex/(V/m)'
set output 'e-x-100.eps'
plot 'bahnkurve.dat' using (100*$3):9
set title 'Ey(x) (Up=100V)'
set ylabel 'Ey/(V/m)'
set output 'e-y-100.eps'
plot 'bahnkurve.dat' using (100*$3):10


######################################################################
set term post
set output 'bahnkurven.eps'
set xrange [-2e-2:16.5e-2]
set yrange [0:4e-2]
set grid
set noborder
set ytics 2.5e-3
set xtics 1e-2
plot 'bahnkurve25.dat' using 3:4,\
     'bahnkurve50.dat' using 3:4,\
     'bahnkurve100.dat' using 3:4

!echo -e "quit\n" > bahnkurve.eps
